<?php

$className = 'RBSPayment';
$paymentName = 'RBSPayment Checkout gateway';

include 'standalone.php';

$objectTypesCollection = umiObjectTypesCollection::getInstance();
$internalTypeId = $objectTypesCollection->getTypeIdByGUID('emarket-paymenttype');

$sel = new selector('objects');
$sel->types('object-type')->id($internalTypeId);
$sel->where('class_name')->equals($className);
$sel->limit(0, 1);

$bAdd = $sel->length() == 0;

$fieldTypesCollection = umiFieldTypesCollection::getInstance();
$typeBoolean = $fieldTypesCollection->getFieldTypeByDataType('boolean');
$typeString = $fieldTypesCollection->getFieldTypeByDataType('string');
$typeInt = $fieldTypesCollection->getFieldTypeByDataType('int');

if ($bAdd) {
    $objectsCollection = umiObjectsCollection::getInstance();

    $parentTypeId = $objectTypesCollection->getTypeIdByGUID('emarket-payment');

    $typeId = $objectTypesCollection->addType($parentTypeId, $paymentName);

    $objectType = $objectTypesCollection->getType($typeId);

    $groupdId = $objectType->addFieldsGroup('settings', 'Settings', true, true);
    $group = $objectType->getFieldsGroupByName('settings');

    $fieldsCollection = umiFieldsCollection::getInstance();

    $fieldTypesCollection = umiFieldTypesCollection::getInstance();
    $typeBoolean = $fieldTypesCollection->getFieldTypeByDataType('boolean')->getId();
    $typeString = $fieldTypesCollection->getFieldTypeByDataType('string')->getId();
    $typeInt = $fieldTypesCollection->getFieldTypeByDataType('int')->getId();
    $typeSelect = $fieldTypesCollection->getFieldTypeByDataType('relation')->getId();

    $idRBSTestMode = $objectTypesCollection->addType(1, 'rbs-testMode');
    $idRBSTwoStage = $objectTypesCollection->addType(1, 'rbs-twoStage');
    $idRBSLogging = $objectTypesCollection->addType(1, 'rbs-logging');

    $idRBSTaxSystem = $objectTypesCollection->addType(1, 'rbs-taxType');
    $idRBSFFDVersion = $objectTypesCollection->addType(1, 'rbs-FFDVersion');
    $idRBSPaymentMethod = $objectTypesCollection->addType(1, 'rbs-paymentMethod');
    $idRBSPaymentObject = $objectTypesCollection->addType(1, 'rbs-paymentObject');

    $idRBSSendOrder = $objectTypesCollection->addType(1, 'rbs-sendOrder');
//    $idDeliveryTax = $objectTypesCollection->addType(1, 'rbs-taxType_delivery');

    $optionTaxSystem = array(
        '0' => 'General (0)',
        '1' => 'Simplified, income (1)',
        '2' => 'Simplified, income minus expences (2)',
        '3' => 'Unified tax on imputed income (3)',
        '4' => 'Unified agricultural tax (4)',
        '5' => 'Patent taxation system (5)',
    );
    $optionTaxType = array(
        0 => 'No VAT (0)',
        1 => 'VAT 0% (1)',
        2 => 'VAT 10% (2)',
        3 => 'VAT 18% (3)',
        6 => 'VAT 20% (6)',
        4 => 'VAT applicable rate 10/110 (4)',
        5 => 'VAT applicable rate 18/118 (5)',
        7 => 'VAT applicable rate 20/120 (7)',
    );

    $optionFFDVersion = array(
        'v1_05' => 'v1.05',
        'v1_2' => 'v1.2',
    );

    $optionPaymentMethod = array(
        1 => 'Full prepayment (1)',
        2 => 'Partial prepayment (2)',
        3 => 'Advance payment (3)',
        4 => 'Full payment (4)',
        5 => 'Partial payment with further credit (5)',
        6 => 'No payment with further credit (6)',
        7 => 'Payment on credit (7)',
    );
    $optionPaymentObject = array(
        1 => 'Goods (1)',
        2 => 'Excised goods (2)',
        3 => 'Job (3)',
        4 => 'Service (4)',
        5 => 'Stake in gambling (5)',
        7 => 'Lottery ticket (7)',
        9 => 'Intellectual property provision (9)',
        10 => 'Payment (10)',
        11 => 'Agent\'s commission (11)',
        12 => 'Combined (12)',
        13 => 'Other (13)',
    );

    $objectsCollection = umiObjectsCollection::getInstance();

//    foreach ($optionTestMode as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSTestMode);
//    }
//    foreach ($optionTwoStage as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSTwoStage);
//    }
//    foreach ($optionSendOrder as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSSendOrder);
//    }
    foreach ($optionTaxType as $key => $value) {
        $objectsCollection->addObject($value, $idRBSTaxSystem);
    }
    foreach ($optionFFDVersion as $key => $value) {
        $objectsCollection->addObject($value, $idRBSFFDVersion);
    }
    foreach ($optionPaymentMethod as $key => $value) {
        $objectsCollection->addObject($value, $idRBSPaymentMethod);
    }
    foreach ($optionPaymentObject as $key => $value) {
        $objectsCollection->addObject($value, $idRBSPaymentObject);
    }
//    foreach ($optionLogging as $key => $value) {
//        $objectsCollection->addObject($value, $idRBSLogging);
//    }

    $fields = array(
        'payment_type_id' => array(
            'name' => 'Method title',
            'type' => $typeSelect,
            'guide_id' => $internalTypeId,
            'required' => true,
        ),
        'rbspayment_user_name' => array(
            'name' => 'Login',
            'type' => $typeString,
            'required' => true,
        ),
        'rbspayment_password' => array(
            'name' => 'Password',
            'type' => $typeString,
            'required' => true,
        ),
        'rbspayment_test_mode' => array(
            'name' => 'Test mode',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSTestMode,
            'required' => true,
        ),
        'rbspayment_two_stage' => array(
            'name' => 'Two stage payments',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSTwoStage,
            'required' => true,
        ),
        'rbspayment_send_order' => array(
            'name' => 'Send order data',
            'type' => $typeBoolean,
//            'guide_id' => $idRBSSendOrder,
            'required' => true,
        ),
        'rbspayment_tax_system' => array(
            'name' => 'Tax System',
            'type' => $typeSelect,
            'guide_id' => $idRBSTaxSystem,
            'required' => true,
        ),
        'rbspayment_FFDVersion' => array(
            'name' => 'FFD Version',
            'type' => $typeSelect,
            'guide_id' => $idRBSFFDVersion,
            'required' => true,
        ),
        'rbspayment_payment_methodType' => array(
            'name' => 'Payment method',
            'type' => $typeSelect,
            'guide_id' => $idRBSPaymentMethod,
            'required' => true,
        ),
        'rbspayment_payment_objectType' => array(
            'name' => 'Payment type',
            'type' => $typeSelect,
            'guide_id' => $idRBSPaymentObject,
            'required' => true,
        )
    );

    foreach ($fields as $code => $arField) {
        $fieldId = $fieldsCollection->addField($code, $arField['name'], $arField['type']);
        $field = $fieldsCollection->getField($fieldId);

        $isRequired = isset($arField['required']) ? $arField['required'] : false;
        if (isset($arField['guide_id'])) {
            $field->setGuideId($arField['guide_id']);
        }
        $field->setIsRequired($isRequired);
        $field->setIsInSearch(false);
        $field->setIsInFilter(false);
        $field->commit();

        $group->attachField($fieldId);
    }

    $internalObjectId = $objectsCollection->addObject($paymentName, $internalTypeId);
    $internalObject = $objectsCollection->getObject($internalObjectId);
    $internalObject->setValue('class_name', $className); // имя класса для реализации

    $internalObject->setValue('payment_type_id', $typeId);
    $internalObject->setValue('payment_type_guid', 'emarket-payment-' . $typeId);
    $internalObject->commit();

    $objectType = $objectTypesCollection->getType($typeId);
    $objectType->setGUID($internalObject->getValue('payment_type_guid'));
    $objectType->commit();

    echo 'RBSPayment Checkout gateway installed successfully. id #' . $typeId;
} else {
    echo 'Error: ' . $className . ' already exist!';
}

//unlink(__FILE__);